// Generated by CoffeeScript 1.6.3
var RemoteContext, Socket, _;

_ = require('../vendor/lodash');

Socket = require("net").Socket;

module.exports = RemoteContext = (function() {
  function RemoteContext() {
    this.id = '...';
    this.guid = '...';
    this.data = {};
    this.events = {};
  }

  RemoteContext.prototype.get = function(k) {
    return this.data[k];
  };

  RemoteContext.prototype.set = function(k, v) {
    return this.data[k] = v;
  };

  RemoteContext.prototype.combine = function(ctx) {
    if (ctx.id !== this.id || ctx.guid !== this.guid) {
      return;
    }
    this.data = ctx.data = _.merge(this.data, ctx.data);
    return this.events = ctx.events = _.merge(this.events, ctx.events);
  };

  RemoteContext.prototype.getAddr = function(stream) {
    var sock;
    if (process.browser) {
      return;
    }
    if (stream instanceof Socket) {
      sock = stream;
    } else if (stream.connection instanceof Socket) {
      sock = stream.connection;
    }
    if (sock) {
      this.ip = sock.remoteAddress;
      return this.port = sock.remotePort;
    }
  };

  RemoteContext.prototype.getMeta = function(meta) {
    var e, _i, _len, _ref, _results;
    this.id = meta.id, this.guid = meta.guid;
    _ref = meta.events;
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      e = _ref[_i];
      _results.push(this.events[e] = 1);
    }
    return _results;
  };

  return RemoteContext;

})();

/*
//@ sourceMappingURL=context.map
*/
