// Generated by CoffeeScript 1.6.3
var filterRequest, pkg, types, util, _;

_ = require('../../vendor/lodash');

pkg = require('../../package.json');

util = require('util');

types = {
  http: require('http'),
  https: require('https')
};

filterRequest = function(req) {
  return /^pnode\/0\.1\.\d+$/.test(req.headers['user-agent']);
};

exports.createServer = function(emitter, type, args, serverArgs) {
  var addr, filter, handlers, http, listening, s;
  http = types[type];
  if (args[0] instanceof http.Server) {
    s = args[0];
    filter = typeof args[1] === 'function' ? args[1] : filterRequest;
  } else {
    s = http.createServer.apply(null, serverArgs);
    filter = filterRequest;
    s.listen.apply(s, args);
  }
  handlers = s.listeners('request').slice(0);
  s.removeAllListeners('request');
  s.on('request', function(req, res) {
    var _this = this;
    if (filter(req)) {
      return emitter.emit('stream', req, res);
    } else {
      return handlers.forEach(function(fn) {
        return fn.call(_this, req, res);
      });
    }
  });
  addr = s.address();
  listening = function() {
    if (!addr) {
      addr = s.address();
    }
    if (typeof addr === 'object') {
      addr = "" + addr.address + ":" + addr.port;
    }
    emitter.emit('uri', "" + type + "://" + addr);
    emitter.emit('bound');
    return emitter.once('unbind', function() {
      return s.close();
    });
  };
  if (addr) {
    listening();
  } else {
    s.once('listening', listening);
  }
  s.once('close', function() {
    return emitter.emit('unbound');
  });
};

exports.createClient = function(emitter, type, reqArgs, extraOpts) {
  var opts, write;
  if (extraOpts == null) {
    extraOpts = {};
  }
  opts = {
    path: '/' + pkg.name,
    headers: {
      'user-agent': pkg.name + '/' + pkg.version,
      'transfer-encoding': 'chunked',
      'expect': '100-continue'
    }
  };
  _.merge(opts, extraOpts);
  if (typeof reqArgs[0] === 'number') {
    opts.port = reqArgs.shift();
  } else {
    throw new Error("bind " + type + " error: missing port");
  }
  if (typeof reqArgs[0] === 'string') {
    opts.hostname = reqArgs.shift();
  }
  emitter.emit('uri', "" + type + "://" + (opts.hostname || 'localhost') + ":" + opts.port);
  write = types[type].request(opts, function(read) {
    emitter.once('unbind', function() {
      return read.socket.end();
    });
    read.once('end', function() {
      return emitter.emit('unbound');
    });
    emitter.emit('read', read);
    emitter.emit('bound');
  });
  emitter.emit('write', write);
};

/*
//@ sourceMappingURL=http-common.map
*/
